// objects.h
// (C) 1997, 1998 lars brinkhoff

#ifndef OBJECTS_H
#define OBJECTS_H

#include "ray.h"

typedef struct Material_struct Material;

typedef struct
{
  Real (*intersection) (void *, Ray *);
  void (*normal) (Vector *, void *, Vector *, Real);
  const Material *material;
  const Matrix *motion;
} Object;

struct Material_struct
{
  Real emit, spec, diff, grain;
  void (*f) (Object *, Vector *, Vector *, Material *);
};

typedef struct Sky_struct Sky;
struct Sky_struct
{
  Real (*f) (Sky *, Vector *);
  Vector up;
};

extern Object create_object (Real (*) (void *, Ray *),
			     void (*) (Vector *, void *, Vector *, Real),
			     const Material *,
			     const Matrix *);

extern Material *create_material (Real, Real, Real, Real);

extern Object *create_sphere (Vector, Real, const Material *, const Matrix *);
extern Object *create_ring (Vector, Vector, Real, Real,
			    const Material *, const Matrix *);
extern Object *create_tri (Vector, Vector, Vector, Vector, Vector, Vector,
			   const Material *, const Matrix *);

#endif
