// parse.c
// (C) 1998 lars brinkhoff
// GPL etc.

#include "parser.h"

void
parse_input (void)
{
  Parser *parser = create_simple_parser ();

  parser->read_scene ();
  //parser->read_commands ();
}

#if 0
  if (0)
    {
      sky.f = sky_black;
      sky.up = vec (0, 1, 0);

      objects[0] = create_sphere (vec (0.0, 30.0, 0.0), 40.0,
				  &matte_white_mat, &E);
      
      options.N += 4;
      
      for (i = 1; i < 11; i++)
	{
	  Real x, z;
	  
	  x = 80 * cos (2 * pi * i / 10.0 +
			2 * pi / 10.0 / 16.0 * options.N);
	  z = 80 * sin (2 * pi * i / 10.0 +
			2 * pi / 10.0 / 16.0 * options.N);
	  objects[i] = create_sphere (vec (x, -20.0, z), 15.0,
				      &matte_white_mat, &E);
	}
      
      objects[i++] = create_sphere (vec (60.0, 60.0, -30.0), 15.0,
				    &light30_mat, &E);
      objects[i++] = create_sphere (vec (45, 75, -40), 5,
				    &matte_white_mat, &E);
      
      objects[i++] = create_ring (vec (60, 60, -30),
				  vec (2, 4, -1),
				  25, 20,
				  &matte_white_mat, &E);

      objects[i++] = create_ring (vec (0, -35, 0.0),
				  vec (0, 1, 0),
				  100, 60,
				  &matte_white_mat, &E);
    }
  else if (0)
    {
      Real r = 15.0;
      int a, b, c;
      Matrix m;
      
      m = matrix_multiply (matrix_rot_x (-0.2 * pi), 
			   matrix_rot_y (0.2 * pi));
      
      for (a = 4; a > 0; a--)
	for (b = a; b > 0; b--)
	  for (c = a; c > 0; c--)
	    objects[i++] = create_sphere (xv (m, r * (2 * b - a - 1),
					      r * (2 - a),
					      r * (2 * c - a - 1)), r,
					  &mirror_mat,
					  &E);
      
      
      m = matrix_rot_x (-0.2 * pi);
      
      objects[i++] = create_ring (xv (m, 0, (r / sqrt (2)) * -2 - r, 0),
				  xv (m, 0, 1, 0), 1000, 0,
				  &checkerboard_mat,
				  &E);
      
      objects[i++] = create_sphere (xv (m, 200, 200, -200), 150, &light10_mat,
				    &E);
      
      objects[i++] = create_sphere (xv (m, 0, 300, 0), 200, &light10_mat, &E);
      
      objects[i++] = create_sphere (xv (m, -300 + options.N * 30, 0, -200), 80,
				    &mirror_mat, &E);
    }
  else if (0)
    {
      // A motion-blurred rind spinning half a revolution.

      Matrix m = matrix_rot_y (options.N * 0.1 * pi);
      Matrix Dm = matrix_rot_y (0.1 * pi);
      //Matrix m = matrix_translate (vec (30, 0, 0));
      //Matrix m = matrix_multiply (matrix_rot_y (0.5 * pi),
      //			matrix_translate (vec (60, 0, 0)));
      objects[i++] = create_ring (xv (m, 0, 0, 0), xv (m, 0, 0, -1), 30, 50,
				  &light1_mat, &Dm);
    }
  else if (0)
    {
      // Three stacked white balls on top of a blurred mirror.

      Matrix m;

      m = matrix_multiply (matrix_translate (vec (0, 0, 0)),
			   matrix_rot_x (options.N * -0.01 * pi));

      objects[i++] = create_sphere (xv (m, 0, 0, 0), 20,
				    &mirror_mat, &E);
      objects[i++] = create_sphere (xv (m, 0, 40, 0), 20,
				    &mirror_mat, &E);
      objects[i++] = create_sphere (xv (m, 0, 80, 0), 20,
				    &mirror_mat, &E);
      objects[i++] = create_ring (xv (m, 0, -20, 0),
				  xv (m, 0, 1, 0), 0, 60,
				  &blurred_mirror_mat, &E);
      /*
      objects[i++] = create_sphere (xv (m, 100, 200, 0), 100,
				    &light1_mat, &E);
      objects[i++] = create_sphere (xv (m, -100, 200, 0), 100,
				    &light10_mat, &E);
				    */
      sky.f = sky_day;
      sky.up = xv (m, 0, 1, 0);
    }
  else if (0)
    {
      objects[i++] = create_ring (vec (-50, 0, 0), vec (0, 1, -1), 0, 40,
				  &mirror_mat, &E);
      objects[i++] = create_tri (vec (10, 0, 0),
				 vec (90, 90, -0),
				 vec (90, -90, 0),
				 vec (1, 0, -1),
				 vec (0, -1, -1),
				 vec (0, 1, -1),
				 &mirror_mat, &E);
    }
  else if (0)
    {
      sky.f = sky_black;

      // floor
      objects[i++] = create_ring (vec (0, -70, 0),
				  vec (0, 1, 0),
				  0, 500,
				  &matte_white_mat, &E);
      // roof
      objects[i++] = create_ring (vec (0, 150, 0),
				  vec (0, -1, 0),
				  0, 500,
				  &matte_white_mat, &E);
      // left wall
      objects[i++] = create_ring (vec (-100, 0, 0),
				  vec (1, 0, 0),
				  0, 500,
				  &matte_white_mat, &E);
      // right wall
      objects[i++] = create_ring (vec (100, 0, 0),
				  vec (-1, 0, 0),
				  0, 500,
				  &matte_white_mat, &E);
      // back wall
      objects[i++] = create_ring (vec (0, 0, 100),
				  vec (0, 0, -1),
				  0, 500,
				  &matte_white_mat, &E);
      // ball floating above floor
      objects[i++] = create_sphere (vec (20, 0, 0), 40,
				    &matte_white_mat, &E);
      // light source
      objects[i++] = create_ring (vec (100, 100, 0),
				  vec (-1, -1, 0),
				  0, 500,
				  &light10_mat, &E);
    }
  
  objects[i] = 0;
  render (options.width, options.height, options.rays_per_pixel);
  render (80, 80, 8);
#endif
