// lasrc/image_out_device.h
// (C) 1998 lars brinkhoff

#ifndef IMAGE_OUT_DEVICE_H
#define IMAGE_OUT_DEVICE_H

#include "config.h"

typedef struct Image_out_device_struct Image_out_device;
struct Image_out_device_struct
{
  int width, height, scale;
  double gamma;
  void (*pixel) (Image_out_device *, int, int, double, double, double);
  void (*wait) (Image_out_device *);
  void (*close) (Image_out_device *);
};

#ifdef HAVE_X
extern Image_out_device *create_x_image_out_device (char *, int, int, int,
						    double);
#endif
#ifdef HAVE_AA
extern Image_out_device *create_aa_image_out_device (char *, int, int, int,
						     double);
#endif
#ifdef HAVE_PNG
extern Image_out_device *create_pgb_image_out_device (char *, int, int, int,
						      double);
#endif
extern Image_out_device *create_rgb_image_out_device (char *, int, int,
							   int, double);
extern Image_out_device *create_vt100_image_out_device (char *, int, int, int,
							double);

#endif
