// lasrc/server.h
// (C) 1998 lars brinkhoff

#ifndef SERVER_H
#define SERVER_H

#include <sys/types.h>
#include "lasrc.h"
#include "image_out_device.h"

// Private data, don't touch.

typedef struct
{
  int x, y;
  int w, h;
  int x0, y0;
  int socket;
  unsigned char remaining_buf[100];
  size_t remaining_n;
} Server;

// Public interface.

int server_fd (Server *);
extern Server *open_server (char *, int, char *);
void server_draw_area (Server *, int, int, int, int, int, int, int);
int server_receive_data (Server *, Image_out_device *, Image_out_device *,
			 unsigned char *, size_t);
void close_server (Server *);

// Return values for server_receive_data ().

#define SERVER_NOT_DONE 1
#define SERVER_DONE 2
#define SERVER_ERROR 3

#endif
