// aa.c
// (C) 1998 lars brinkhoff

#include <aalib.h>

#include "pix.h"

struct info
{
  aa_context *C;
  struct Options *options;
}
  
static unsigned char fontdata [8 * 256];
static struct aa_font font = { fontdata, 8, "", "" };

#include "f8d.h"

void *
init_aa (struct Options *options)
{
  struct info *info;
  char *p;
  
  info = malloc (sizeof (struct info));
  if (info == 0)
    return 0;
  
  memset (fontdata, 0, 8 * 256);
  for (p = ",'`^:I<>+_-[]{}()|\\/jxXYULQOoZdb#MW8B@T"; *p; p++)
    memcpy (fontdata + 8 * (*p), font8dat + 8 * (*p), 8);
  hardware_params.font = &font;
  hardware_params.supported = AA_NORMAL_MASK;
  hardware_params.minwidth =
    hardware_params.minheight =
    hardware_params.maxwidth =
    hardware_params.maxheight =
    hardware_params.recwidth =
    hardware_params.recheight = 0;
  hardware_params.width = (options->width + 1) / 2;
  hardware_params.height = (options->height + 1) / 2;
  hardware_params.dimmul = 0;
  hardware_params.boldmul = 0;
  info->C = aa_autoinit (&hardware_params);
}

void pixel_aa (void *info_, int x, int y, double r, double g, double b)
{
  struct info *info = info_;
  static struct aa_hardware_params hardware_params;
  double i;
  int j;

  i = 0.3 * r + 0.6 * g + 0.1 * b;
  j = (int)(255 * i + .5) >> 4;
  aa_putpixel (info->C, x, y, j);

  if (x + 1 == info->options->width &&
      y + 1 == info->options->height)
    {
      struct aa_renderparams renderparams = { 0, 0, 0.0, AA_NONE, 0, 0 };
      aa_render (info->C,
		 &renderparams,
		 0, 0,
		 info->options->width,
		 options->height);
      aa_flush (info->C);
      aa_close (info->C);
    }
}
